setOldClass(c("tssa", "tree"))

"tssa"<-
function(formula = formula(data), delta, weights = F, data = sys.parent(),
	subset, na.action = na.omit, method = "recursive.partition", propn =
	0.14999999999999999, choice = "Mantel-Haenzel", maxnodes = 50, minbuc
	 = 30, model = NULL, x = F, y = T, ...)
{
### @(#) tssa.q 1.16 96/08/26 12:02:38
### /home/carrie/dist/tssa/SCCS/s.tssa.q
###
### Copyright (C) 1996  Carrie Wager and Mark Segal.
###
### This program is free software; you can redistribute it and/or modify
### it under the terms of the GNU General Public License as published by
### the Free Software Foundation; either version 2 of the License, or
### (at your option) any later version.
###
### This program is distributed in the hope that it will be useful,
### but WITHOUT ANY WARRANTY; without even the implied warranty of
### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
### GNU General Public License for more details.
###
### You should have received a copy of the GNU General Public License
### along with this program; if not, write to the Free Software
### Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###
### You may contact the authors via email: cwager@hsph.harvard.edu
### or mark@biostat.ucsf.edu, or by snail mail at:
###
### --------------------------------------------------------------------
### | Mark Segal                                                        |
### | Division of Biostatistics, University of California,  MU 420 West |
### | 500 Parnassus Avenue,  San Francisco,  CA  94143-0560             |
### --------------------------------------------------------------------
###
	epsilon <- 9.9999999999999995e-07
	if(is.null(model)) {
		model <- match.call(expand = F)
		model$method <- model$model <- model$... <- NULL
		model$propn <- model$choice <- model$epsilon <- model$maxnodes <-
			model$minbuc <- model$x <- model$y <- NULL
		if(deparse(substitute(weights)) == "F")
			model$weights <- NULL
		model[[1]] <- as.name("model.frame.default")
		model <- eval(model, sys.parent())
		if(method == "model.frame")
			return(model)
	}
	Terms <- attr(model, "terms")
	if(any(attr(Terms, "order") > 1))
		stop("Trees cannot handle interaction terms")
	Y <- model.extract(model, "response")
	if(is.matrix(Y) && ncol(Y) > 1)
		stop("Trees cannot handle multivariate response")
	if(length(levels(Y)))
		warn("Survival Trees will ignore levels in Y")
	offset <- attr(Terms, "offset")
	if(!is.null(offset)) {
		offset <- model[[offset]]
		Y <- Y - offset
	}
	ind <- seq(along = names(model))[names(model) == "(delta)"]
	censor <- model[, ind]
	model <- model[,  - ind]
	nobs <- length(Y)
	if(is.na(ind <- match("(weights)", names(model))))
		weights <- rep(1, nobs)
	else {
		weights <- model[, ind]
		model <- model[,  - ind]
	}
	attr(model, "terms") <- Terms
	X <- tree.matrix(model)
	xlevels <- attr(X, "column.levels")
	if(is.null(xlevels)) {
		xlevels <- rep(list(NULL), ncol(X))
		names(xlevels) <- dimnames(X)[[2]]
	}
	choices <- c("Mantel-Haenzel", "Gehan", "Tarone", "Prentice", "user")
	if(choice == "")
		stop(paste("unknown choice: (blank)"))
	if((ichoice <- charmatch(choice, choices, -1)) == -1)
		if((ichoice <- match(choice, as.character(1:5), -1)) == -1)
			if((ichoice <- charmatch(choice, "logrank", -1)) == -1
				)
				stop(paste("unknown choice:", choice))
	fit <- .C("tssa",
		as.double(oldUnclass(X)),
		as.double(Y),
		as.double(weights),
		as.integer(censor),
		as.integer(nobs),
		as.integer(ncol(X)),
		as.double(propn),
		as.integer(ichoice),
		as.double(epsilon),
		as.integer(maxnodes),
		as.integer(minbuc),
		node = integer(maxnodes),
		var = integer(maxnodes),
		splitval = double(maxnodes),
		n = integer(maxnodes),
		stat = double(maxnodes),
		yval = double(maxnodes),
		dev = double(maxnodes),
		nnode = integer(1),
		where = integer(nobs))
	n <- fit$nnode + 1
	fit$var <- fit$var + 1
	fit$cutleft <- paste("<", as.character(signif(fit$splitval, 6)), sep =
		"")
	fit$cutleft[fit$var == 0] <- ""
	fit$cutright <- paste(">", as.character(signif(fit$splitval, 6)), sep
		 = "")
	fit$cutright[fit$var == 0] <- ""
	fit$stat[fit$stat == -1] <- NA
	frame <- data.frame(fit[c("var", "n", "stat", "yval")])[1:n,  ]
	frame$var <- factor(frame$var, 0:length(xlevels), c("<leaf>", names(
		xlevels)))
	frame$splits <- array(unlist(fit[c("cutleft", "cutright")]), c(maxnodes,
		2), list(character(0), c("cutleft", "cutright")))[1:n,  , drop
		 = F]
	map <- 1:n
	names(map) <- row.names(frame) <- fit$node[1:n]
	fit$where <- map[as.character(fit$where)]
	fit <- list(frame = frame, where = fit$where, terms = Terms, call =
		match.call(), choice = choices[ichoice])
	attr(fit$where, "names") <- row.names(model)
	if(n > 1)
		attr(fit, "class") <- "tssa"
	else attr(fit, "class") <- "singlenode"
	attr(fit, "xlevels") <- xlevels
	if(x)
		fit$x <- X
	if(y)
		fit$y <- Y
	fit$delta <- censor
	fit
}
"browser.tssa"<-
function(tree, nodes, digits = .Options$digits - 3)
{
	if(!inherits(tree, "tree"))
		stop("Not legitimate tree")
	frame <- tree$frame
	node <- row.names(frame)
	if(!missing(nodes))
		return(frame[node.match(nodes, node),  ])
	labs <- c("node number:", "split:", "n:", "stat:", "yval:")
	is.prob <- !is.null(ylevels <- attr(tree, "ylevels"))
	if(is.prob)
		frame$yval <- as.character(frame$yval)
	else frame$yval <- format(signif(frame$yval, digits = digits))
	frame$stat <- format(signif(frame$stat, digits = digits))
	xy <- treeco(tree)
	splits <- labels.tree(tree, pretty = 0)
	while(length(i <- identify(xy, n = 1, plot = F)) > 0) {
		fi <- frame[i,  , drop = F]
		info <- c(node[i], splits[i], fi$n, fi$stat, fi$yval)
		cat(paste(labs, info, "\n"))
		if(is.prob)
			print(fi$yprob)
	}
	invisible()
}
"data.tree"<-
function(tree)
{
	oc <- tree$call
	while(oc[[1]] != "tree" && oc[[1]] != "tssa") oc <- eval(oc[[2]])$call
	if(is.null(oc$data))
		NULL
	else {
		warning(paste("Retrieving data from", oc$data))
		eval(oc$data)
	}
}
"km.tssa"<-
function(tree, nodes, screen.arg = ascr + 1, plot.it = T, ...)
{
	plot.tssa.km <- function(nodes, where, tree, mt, plot.it = plot.it, ...
		)
	{
		children <- strata <- c()
		indices <- identify.tree(tree, nodes)
		if(mode(indices) == "character") {
			indices <- list(indices)
			names(indices) <- nodes
		}
		for(i in 1:length(indices)) {
			children <- c(children, unlist(indices[i]))
			strata <- c(strata, rep(as.numeric(nodes[i]), length(
				unlist(indices[i]))))
		}
		if(mode(children) == "character") {
			tmpind <- 1:length(tree$where)
			names(tmpind) <- names(where)
			children <- tmpind[children]
		}
		else children <- as.numeric(children)
		s <- surv.fit(tree$y[children], tree$delta[children], strata)
		if(plot.it) {
			par(mar = c(4, 4, 1, 2), err = -1)
			plot(s, ..., mark.time = mt)
			if(length(indices) == 1)
				ends <- length(s$time)
			else ends <- cumsum(table(s$strata))
			text(s$time[ends], s$surv[ends], paste(" ", nodes), adj
				 = 0)
		}
		s$strata.name <- "node"
		s
	}
	if(!inherits(tree, "tssa"))
		stop("Not a legitimate survival tree")
	if(is.null(tree$y))
		stop("tssa object has no y attribute: must run tssa with y=T")
	if(is.null(mincut <- tree$call$mincut))
		mincut <- tree$call$control$mincut
	if(is.null(mincut))
		mincut <- 5
	where <- tree$where
	frame <- tree$frame
	node <- as.numeric(row.names(frame))
	leaves <- frame$var == "<leaf>"	#
#
	if(missing(nodes)) {
		if(!plot.it) stop("plot.it must be TRUE if no nodes are supplied!"
				)	#
# Label nodes on upper screen.
		if(!(ascr <- screen()))
			stop("Need to invoke tssa.screens or tree.screens")
		screen(ascr, F)
		cxy <- par("cxy")[2]
		xy <- treeco(tree)	# #leaves <- frame$var == "<leaf>"
		text(xy$x[leaves], xy$y[leaves] + 0.5 * cxy, row.names(frame)[
			leaves], adj = 1, cex = 0.80000000000000004)
		text(xy$x[!leaves], xy$y[!leaves] - 0.5 * cxy, row.names(frame)[
			!leaves], cex = 0.80000000000000004)
		xy <- treeco(tree)
		cat("click left mouse button on a non-terminal node\n")
		while(length(i <- identify(xy, n = 1, plot = F)) > 0) {
			if(leaves[i]) {
				cat("Leaf node --- choose another\n")
				next
			}
			screen(screen.arg, new = T)
			retval <- plot.tssa.km(c(node[i] * 2, node[i] * 2 + 1),
				where, tree, T, plot.it = T, ...)
			screen(ascr, F)
		}
	}
	else {
		mt <- F
		if(nodes[1] == "terminal")
			nodes <- ((row.names(frame))[leaves])
		else if(nodes[1] == "all")
			nodes <- (row.names(frame))
		else mt <- T
		if(length(nodes) == 0)
			return(invisible())
		if(plot.it) {
			if(ascr <- screen()) screen(screen.arg, new = T)
	#			stop(
#			  "Need to invoke tssa.screens or set 'plot.it=FALSE'"
#			  )
#		screen(screen.arg, new = T)
			retval <- plot.tssa.km(nodes, where, tree, mt, plot.it
				 = T, ...)
			if(ascr)
				screen(ascr, F)
		}
		else retval <- plot.tssa.km(nodes, where, tree, mt, plot.it = F
				)
	}
	invisible(retval)
}
"model.frame.tssa"<-
function(formula, ...)
{
	m <- formula$model
	if(!is.null(m))
		return(m)
	oc <- formula$call
	if(substring(oc[[1]], 1, 7) == "predict") {
		m <- eval(oc$newdata, local = F)
		if(is.null(attr(m, "terms"))) {
			object <- eval(oc$object, local = F)
			m <- model.frame(object$terms, m, na.tree.replace)
		}
		return(m)
	}
	while(oc[[1]] != "tssa") oc <- eval(oc[[2]], local = F)$call
	oc$subset <- names(formula$where)
	oc$method <- "model.frame"
	eval(oc, local = F)
}
"plot.tssa"<-
function(x, y = NULL, type = NULL, ...)
{
	if(!inherits(x, "tssa"))
		stop("Not legitimate tssa object")
	if(ascr <- screen()) {
		if(!is.na(match(screen() + 1, close.screen())))
			screen(ascr + 1)
		screen(ascr)
	}
	invisible(plot.tree(x, y, y = y, type = type, ...))
}
"post.tssa"<-
function(tree, title = deparse(substitute(tree)), file = paste(deparse(
	substitute(tree)), ".ps", sep = ""), digits = .Options$digits - 3,
	pretty = 0, pointsize = 10)
{
	frame <- tree$frame
	n <- dim(frame)[1]
	xlevels <- attr(tree, "xlevels")
	splits <- labels.tree(tree, pretty = pretty, collapse = F)
	ndelta <- rep(0, len <- dim(frame)[1])
	ndelta[frame$var == "<leaf>"] <- tapply(tree$delta, tree$where, sum)
	which <- descendants(as.numeric(row.names(frame)))
	mode(which) <- "numeric"
	ndelta <- apply(which * matrix(rep(ndelta, len), nrow = len, byrow = T),
		1, sum)
	below <- paste(format(signif(ndelta, digits = digits)), "/", format(
		signif(frame$n, digits = digits)), sep = "")
	inside <- format(signif(frame$yval, digits = digits))
	xy <- .C("post",
		as.integer(frame$var != "<leaf>"),
		as.character(splits[, 1]),
		as.character(splits[, 2]),
		as.character(inside),
		as.character(below),
		as.integer(row.names(frame)),
		as.integer(n),
		as.character(title),
		as.character(file),
		as.double(pointsize),
		x = double(n),
		y = double(n))
	invisible(list(x = xy$x, y = xy$y))
}
"print.summary.tssa"<-
function(x, digits = max(.Options$digits - 3, 3), ...)
{
	cat(x$type)
	dput(x$call)
	if(mode(x$call$formula) == "name")
		cat("   formula: ", x$formula[2], "~", x$formula[3:length(x$
			formula)], "\n")
	if(!is.null(x$used)) {
		cat("Variables actually used in tree construction: \n")
		cat("    ", as.character(x$used), "\n")
	}
	cat(paste("Number of terminal nodes: ", x$size, "\n"))
	if(!is.null(x$effect.size)) cat("Effective number of terminal nodes: ",
			format(signif(x$effect.size, digits)), "\n")
	#	cat(paste("Residual mean deviance: ", format(signif(x$dev/x$df, digits)
#		), "=", format(signif(x$dev, digits)), "/", format(signif(x$df,
#		digits)), "\n"))
#	if(!is.null(x$misclass))
#		cat("Misclassification error rate:", format(signif(x$misclass[1
#			]/x$misclass[2], digits)), "=", x$misclass[1], "/", x$
#			misclass[2], "\n")
#	else {
#		cat("Distribution of residuals:\n")
#		print(summary(x$residuals, digits = digits, ...))
#	}
	invisible(x)
}
"print.tssa"<-
function(x, pretty = 0, spaces = 2, digits = .Options$digits - 3, ...)
{
#spaces is used for indentation of tree levels
	if(!inherits(x, "tssa")) stop("Not legitimate survival tree")
	cat("node), split, (n, failures), km-median, split-statistic\n")
	cat("      * denotes terminal node, choice is", x$choice, "\n\n")
	frame <- x$frame
	node <- as.numeric(row.names(frame))
	depth <- tree.depth(node)
	indent <- paste(rep(" ", spaces * 32), collapse = "")
	#32 is the maximal depth
	if((len <- length(node)) > 1) {
		indent <- substring(indent, 1, spaces * seq(depth))
		indent <- paste(c("", indent[depth]), format(node), ")", sep =
			"")
	}
	else indent <- paste(format(node), ")", sep = "")
	yval <- format(signif(frame$yval, digits = digits))
	z <- labels.tree(x, pretty = pretty)
	if(inherits(x, "bonzai"))
		n <- format(signif(frame$n, digits = digits))
	else n <- frame$n
	ndelta <- rep(0, len)
	#	ndelta[frame$var == "<leaf>"] <- tapply(x$delta[as.numeric(names(x$
#		where))], x$where, sum)
	ndelta[frame$var == "<leaf>"] <- tapply(x$delta, x$where, sum)
	which <- descendants(as.numeric(row.names(frame)))
	mode(which) <- "numeric"
	ndelta <- apply(which * matrix(rep(ndelta, len), nrow = len, byrow = T),
		1, sum)
	stat <- as.character(format(round(frame$stat, 2)))
	#	spropn <- as.character(100 - round((ndelta * 100)/n, 1))
	stat[is.na(frame$stat) | frame$var == "<leaf>"] <- "*"
	z <- paste(indent, z, paste("(", n, ",", ndelta, ")", sep = ""), yval,
		stat)
	cat(z, sep = "\n")
	invisible(x)
}
"prune"<-
function(x, ...)
UseMethod("prune")
"prune.tssa"<-
function(tree, screen.arg = ascr + 1)
{
	.snip.tree <- function(tree, nodes)
	{
#
# This is copied from snip.tree.
#
		where <- tree$where
		frame <- tree$frame
		node <- as.numeric(row.names(frame))
		if(is.null(frame$which))
			frame$which <- descendants(node, F)
		i <- match(nodes, node)
		frame$var[i] <- "<leaf>"
		frame$stat[i] <- NA
		frame$splits[i,  ] <- ""
		ii <- frame$which[i,  , drop = F]
		keep <- !apply(ii, 2, any)
		frame <- frame[keep,  , drop = F]
		frame$which <- frame$which[, keep, drop = F]
		where <- match(node[where], node[keep])
		nn <- match(nodes, node[keep])
		for(n in seq(length(nodes)))
			where[ii[n, tree$where]] <- nn[n]
		tree$frame <- frame
		tree$where <- structure(where, names = names(tree$where))
		tree
	}
#
# Initializations
#
	if(!inherits(tree, "tssa"))
		stop("Not legitimate survival tree")
	frame <- tree$frame
	node <- as.numeric(row.names(frame))
	tree$frame$which <- descendants(node, include = F)
	len <- length(node)	#
#
# Calculate maximum split statistic
#    and number of terminal nodes after each snip.
#
	numterm <- function(x)
	{
		length(x[is.na(match(x, x * 2))])
	}
	n.int <- len - numterm(node)
	frame$mss <- tapply(rep(frame$stat, len) * as.numeric(t(descendants(
		node))), col(tree$frame$which), max, na.rm = T)
	frame$mss[frame$mss == 0] <- NA
	mss.index <- order(frame$mss, len - node)[1:n.int]
	term <- rep(NA, n.int)
	snip.list <- as.vector(NULL, "numeric")
	for(i in 1:n.int) {
		snip.list <- unique(c(snip.list, (1:len)[tree$frame$which[
			mss.index[i],  ]]))
		term[i] <- numterm(node[ - snip.list])
	}
	mss <- list(node = mss.index, stat = frame$mss[mss.index], term = term)
	row.names(mss) <- node[mss.index]	#
#
# Label nodes on upper screen.
#
	if(!(ascr <- screen()))
		stop("Need to invoke tssa.screens or tree.screens")
	screen(ascr, F)
	cxy <- par("cxy")[2]
	xy <- treeco(tree)
	leaves <- frame$var == "<leaf>"
	text(xy$x[leaves], xy$y[leaves] + 0.5 * cxy, row.names(frame)[leaves],
		adj = 1, cex = 0.80000000000000004)
	text(xy$x[!leaves], xy$y[!leaves] - 0.5 * cxy, row.names(frame)[!leaves
		], cex = 0.80000000000000004)	#
#
# Plot mss vs. terminal nodes on lower screen
#
	erase.screen(screen.arg)
	screen(screen.arg)
	par(mar = c(5, 6, 1, 2), err = -1)
	plot(mss$term, mss$stat, xlab = "Number of Terminal Nodes", ylab =
		"Split-statistic")
	lines(mss$term, mss$stat)
	offset1 <- (diff(range(mss$term, na.rm = T))/60)
	offset2 <- (diff(range(mss$stat, na.rm = T))/20)
	text(mss$term + offset1, mss$stat + offset2, node[mss$node], cex = min(
		1,  - length(mss$term)/160 + 17/16))	#
#
# Prompt for mouse clicks on lower screen.
# After 2 clicks on same node, snip nodes from tree in upper screen.
#
	iprev <- i <- 0
	cat("Use mouse in lower screen to snip corresponding nodes...\n")
	while(length(i <- identify(mss$term, mss$stat, n = 1, plot = F)) > 0)
		{
		tnode <- as.numeric(row.names(tree$frame))
		snip <- match(as.numeric(row.names(mss))[1:i] * 2, tnode)
		if(any(!is.na(snip))) {
			snip <- tnode[snip[!is.na(snip)]]/2
			j <- node.match(snip, tnode)
			ii <- apply(tree$frame$which[j,  , drop = F], 2, any)
			if(i != iprev) {
				if(i > iprev)
				  for(k in (iprev + 1):i) {
				    cat("split stats for node", node[mss$node[k
				      ]], "\n")
				    cat("   split statistic: ", round(tree$
				      frame[as.character(node[mss$node[k]]),
				      "stat"], digits = 2), "\n")
				    cat("   maximum split statistic: ", round(
				      mss$stat[k], digits = 2), "\n")
				    cat("\n")
				  }
				iprev <- i
			}
			else {
				screen(ascr, F)
				xy <- treepl(xy, tnode, erase = ii)
				tree <- .snip.tree(tree, snip)
				screen(screen.arg, F)
			}
		}
	}
	screen(ascr, F)
	tree
}
"snip"<-
function(x, ...)
UseMethod("snip")
"snip.tssa"<-
function(tree, nodes, xy.save = F, digits = .Options$digits - 3)
{
	.snip.tree <- function(tree, nodes)
	{
		where <- tree$where
		frame <- tree$frame
		node <- as.numeric(row.names(frame))
		if(is.null(frame$which))
			frame$which <- descendants(node, F)
		i <- match(nodes, node)
		print(i)
		frame$var[i] <- "<leaf>"
		print(frame$var[i])
		frame$splits[i,  ] <- ""
		ii <- frame$which[i,  , drop = F]
		keep <- !apply(ii, 2, any)
		frame <- frame[keep,  , drop = F]
		frame$which <- frame$which[, keep, drop = F]
		where <- match(node[where], node[keep])
		nn <- match(nodes, node[keep])
		for(n in seq(length(nodes)))
			where[ii[n, tree$where]] <- nn[n]
		tree$frame <- frame
		tree$where <- structure(where, names = names(tree$where))
		tree
	}
	if(!inherits(tree, "tree"))
		stop("Not legitimate tree")
	call <- match.call()
	node <- as.numeric(row.names(tree$frame))
	if(missing(nodes)) {
		iprev <- i <- 0
		nodes <- NULL
		totdev <- deviance(tree)
		xy <- treeco(tree)
		tree$frame$which <- descendants(node, include = F)
		labs <- c("node number: ", "  tree deviance = ",
			"  subtree deviance = ")
		while(length(i <- identify(xy, n = 1, plot = F)) > 0) {
			if(tree$frame$var[i] == "<leaf>") {
				cat("Terminal node -- try again\n")
				next
			}
			ii <- tree$frame$which[i,  ]
			if(i != iprev) {
				frame <- tree$frame
				dev <- frame$dev
				node <- as.numeric(row.names(frame))
				newdev <- totdev - sum(dev[ii & (frame$var ==
				  "<leaf>")]) + dev[i]
				stats <- c(node[i], format(signif(c(totdev,
				  newdev), digits)))
				cat(paste(labs[1], stats[1], "\n"))
				iprev <- i
			}
			else {
				xy <- treepl(xy, node, erase = ii)
				nodes <- c(nodes, node[i])
				tree <- .snip.tree(tree, node[i])
				totdev <- newdev
			}
		}
		if(xy.save)
			assign(".xy", xy, where = 0)
	}
	else {
		print(i)
		i <- node.match(nodes, node, tree$frame$var == "<leaf>")
		if(length(i) == 0)
			return(tree)
		nodes <- node[i]
		which <- descendants(node, include = T)
		nodes <- nodes[apply(which[i,  ] %*% which[, i], 2, "sum") == 1
			]	#delete dominated nodes
		diag(which) <- F
		tree$frame$which <- which
		tree <- .snip.tree(tree, nodes)
	}
	tree$frame$which <- NULL
	call[["nodes"]] <- nodes
	tree$call <- call
	if(dim(tree$frame)[1] == 1)
		oldClass(tree) <- "singlenode"
	tree
}
"summary.tssa"<-
function(object)
{
	obj <- list(call = object$call)
	frame <- object$frame
	obj$type <- "Survival tree:\n"
	leaves <- frame$var == "<leaf>"
	variables <- names(attr(object, "xlevels"))
	used <- unique(frame$var[!leaves])
	if(length(used) < length(variables)) obj$used <- used	#
	obj$formula <- attr(object$terms, "formula")
	obj$size <- sum(leaves)
	obj$df <- frame$n[1] - obj$size	#
#	obj$dev <- deviance.tree(object)
#	obj$residuals <- residuals(object)
	oldClass(obj) <- "summary.tssa"
	obj
}
"text.surv.fit"<-
function(s)
{
	if(length(table(s$strata)) == 1)
		ends <- length(s$time)
	else ends <- cumsum(table(s$strata))
	print(names(table(s$strata)))
	text(s$time[ends], s$surv[ends], paste(" ", names(table(s$strata))),
		adj = 0)
}
"text.tssa"<-
function(x, splits = T, all = F, pretty = NULL, digits = .Options$digits - 3,
	...)
{
#Put left splits at the parent node
#Allow labels at all or just leaf nodes
	if(!inherits(x, "tssa")) stop("Not legitimate survival tree")
	frame <- x$frame
	col <- names(frame)
	if(!is.null(ylevels <- attr(x, "ylevels")))
		col <- c(col, ylevels)
	cxy <- par("cxy")[2]
	if(!is.null(srt <- list(...)$srt) && srt == 90)
		cxy <- cxy * 4
	xy <- treeco(x)
	if(splits) {
		node <- as.numeric(row.names(frame))
		left.child <- match(2 * node, node)
		rows <- labels.tree(x, pretty = pretty)
		text(xy$x, xy$y + 0.5 * cxy, rows[left.child], ...)
	}
	leaves <- if(all) rep(T, nrow(frame)) else frame$var == "<leaf>"
	len <- length(frame$stat)
	ndelta <- rep(0, len)
	ndelta[frame$var == "<leaf>"] <- tapply(x$delta, x$where, sum)
	which <- descendants(as.numeric(row.names(frame)))
	mode(which) <- "numeric"
	ndelta <- apply(which * matrix(rep(ndelta, len), nrow = len, byrow = T),
		1, sum)
	stat <- paste(ndelta[leaves], "/", frame$n[leaves])
	text(xy$x[leaves], xy$y[leaves] - 0.5 * cxy, stat, ...)
	invisible()
}
"treeco"<-
function(x, ...)
UseMethod("treeco")
"treeco.tree"<-
function(tree, uniform = paste(".Tree.unif", dev.cur(), sep = "."))
{
	frame <- tree$frame
	node <- as.numeric(row.names(frame))
	depth <- tree.depth(node)
	x <-  - depth
	if(exists(uniform, frame = 0))
		uniform <- get(uniform, frame = 0)
	else uniform <- 0
	if(uniform)
		y <- x
	else {
		y <- dev <- frame$dev
		depth <- split(seq(node), depth)
		parent <- match(node %/% 2, node)
		sibling <- match(ifelse(node %% 2, node - 1, node + 1), node)
		for(i in depth[-1])
			y[i] <- y[parent[i]] - dev[parent[i]] + dev[i] + dev[
				sibling[i]]
	}
	depth <-  - x
	leaves <- frame$var == "<leaf>"
	x[leaves] <- seq(sum(leaves))
	depth <- split(seq(node)[!leaves], depth[!leaves])
	left.child <- match(node * 2, node)
	right.child <- match(node * 2 + 1, node)
	for(i in rev(depth))
		x[i] <- 0.5 * (x[left.child[i]] + x[right.child[i]])
	list(x = x, y = y)
}
"treeco.tssa"<-
function(tree, uniform = paste(".Tree.unif", dev.cur(), sep = "."))
{
	frame <- tree$frame
	node <- as.numeric(row.names(frame))
	depth <- tree.depth(node)
	x <-  - depth
	if(exists(uniform, frame = 0))
		uniform <- get(uniform, frame = 0)
	else uniform <- 0
	if(uniform)
		y <- x
	else {
		y <- stat <- frame$stat
		depth <- split(seq(node), depth)
		parent <- match(node %/% 2, node)
		sibling <- match(ifelse(node %% 2, node - 1, node + 1), node)
		y[1] <- sum(stat[!is.na(stat)]) + max(stat[1])
		for(i in depth[-1])
			y[i] <- y[parent[i]] - stat[parent[i]]
	}
	depth <-  - x
	leaves <- frame$var == "<leaf>"
	x[leaves] <- seq(sum(leaves))
	depth <- split(seq(node)[!leaves], depth[!leaves])
	left.child <- match(node * 2, node)
	right.child <- match(node * 2 + 1, node)
	for(i in rev(depth))
		x[i] <- 0.5 * (x[left.child[i]] + x[right.child[i]])
	list(x = x, y = y)
}
"tssa.screens"<-
function(figs, screen.arg = 0, ...)
{
	if(missing(figs))
		figs <- array(c(0, 0, 1, 1, 0.40000000000000002, 0, 1,
			0.40000000000000002), c(2, 4))
	which <- split.screen(figs, screen.arg)
	for(i in which) {
		screen(i)
		par(mar = rep(0, 4), cex = 1, ...)
	}
	screen(which[1])
	which
}
andata <- data.frame(read.table("andata"))
names(andata) <- c("y","delta","age","sex","stage","sympt","perf","grp","dose")
